# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`xdmod`](#xdmod): Manage XDMoD

#### Private Classes

* `xdmod::akrr::config`: Manage XDMoD AKRR configs
* `xdmod::akrr::install`: Manage XDMoD AKRR install
* `xdmod::akrr::service`: Manage XDMoD AKRR service
* `xdmod::akrr::user`: Manage XDMoD AKRR user
* `xdmod::apache`: Manage XDMoD Apache configs
* `xdmod::config`: Manage XDMoD configs
* `xdmod::config::simplesamlphp`: Manage XDMoD simplesamlphp
* `xdmod::database`: Manage XDMoD databases
* `xdmod::install`: Manage XDMoD packages
* `xdmod::params`: XDMoD module defaults
* `xdmod::supremm::compute::pcp`: Manage XDMoD compute PCP
* `xdmod::supremm::config`: Manage XDMoD SUPReMM configs
* `xdmod::supremm::database`: Manage XDMoD SUPReMM databases
* `xdmod::supremm::install`: Manage XDMoD SUPReMM packages
* `xdmod::user`: Manage XDMoD user

### Defined types

* [`xdmod::akrr::setting`](#xdmodakrrsetting): Manage AKRR config setting value

### Resource types

* [`xdmod_appkernel_setting`](#xdmod_appkernel_setting): Section/setting name to manage from appkernels.ini
* [`xdmod_portal_setting`](#xdmod_portal_setting): Section/setting name to manage from portal_settings.ini
* [`xdmod_supremm_setting`](#xdmod_supremm_setting): Section/setting name to manage from supremm.ini

### Functions

* [`xdmod::member_substring`](#xdmodmember_substring): Function to test member substring

### Data types

* [`Xdmod::Hierarchy_Levels`](#xdmodhierarchy_levels)
* [`Xdmod::Resource`](#xdmodresource)
* [`Xdmod::Resource_Spec`](#xdmodresource_spec)
* [`Xdmod::Supremm_Resource`](#xdmodsupremm_resource)

## Classes

### <a name="xdmod"></a>`xdmod`

Manage XDMoD

#### Parameters

The following parameters are available in the `xdmod` class:

* [`version`](#version)
* [`xdmod_appkernels_version`](#xdmod_appkernels_version)
* [`xdmod_supremm_version`](#xdmod_supremm_version)
* [`database`](#database)
* [`web`](#web)
* [`akrr`](#akrr)
* [`supremm`](#supremm)
* [`supremm_database`](#supremm_database)
* [`compute`](#compute)
* [`enable_appkernel`](#enable_appkernel)
* [`enable_supremm`](#enable_supremm)
* [`enable_cloud_realm`](#enable_cloud_realm)
* [`local_repo_name`](#local_repo_name)
* [`manage_epel`](#manage_epel)
* [`package_ensure`](#package_ensure)
* [`xdmod_supremm_package_ensure`](#xdmod_supremm_package_ensure)
* [`xdmod_appkernels_package_ensure`](#xdmod_appkernels_package_ensure)
* [`package_name`](#package_name)
* [`package_url`](#package_url)
* [`appkernels_package_name`](#appkernels_package_name)
* [`appkernels_package_url`](#appkernels_package_url)
* [`xdmod_supremm_package_name`](#xdmod_supremm_package_name)
* [`xdmod_supremm_package_url`](#xdmod_supremm_package_url)
* [`database_host`](#database_host)
* [`database_port`](#database_port)
* [`database_user`](#database_user)
* [`database_password`](#database_password)
* [`akrr_database_user`](#akrr_database_user)
* [`akrr_database_password`](#akrr_database_password)
* [`web_host`](#web_host)
* [`akrr_host`](#akrr_host)
* [`scheduler`](#scheduler)
* [`shredder_command`](#shredder_command)
* [`shred_hour_start`](#shred_hour_start)
* [`shred_minutes`](#shred_minutes)
* [`ingest_hour`](#ingest_hour)
* [`enable_update_check`](#enable_update_check)
* [`manage_apache_vhost`](#manage_apache_vhost)
* [`apache_vhost_name`](#apache_vhost_name)
* [`apache_ssl_cert`](#apache_ssl_cert)
* [`apache_ssl_key`](#apache_ssl_key)
* [`apache_ssl_chain`](#apache_ssl_chain)
* [`portal_settings`](#portal_settings)
* [`hierarchy_levels`](#hierarchy_levels)
* [`hierarchies`](#hierarchies)
* [`group_to_hierarchy`](#group_to_hierarchy)
* [`user_pi_names`](#user_pi_names)
* [`organization_name`](#organization_name)
* [`organization_abbrev`](#organization_abbrev)
* [`resources`](#resources)
* [`resource_specs`](#resource_specs)
* [`sender_email`](#sender_email)
* [`debug_recipient`](#debug_recipient)
* [`php_timezone`](#php_timezone)
* [`center_logo_source`](#center_logo_source)
* [`center_logo_width`](#center_logo_width)
* [`user_dashboard`](#user_dashboard)
* [`cors_domains`](#cors_domains)
* [`manage_user`](#manage_user)
* [`user_uid`](#user_uid)
* [`group_gid`](#group_gid)
* [`data_warehouse_export_directory`](#data_warehouse_export_directory)
* [`data_warehouse_export_retention_duration_days`](#data_warehouse_export_retention_duration_days)
* [`data_warehouse_export_hash_salt`](#data_warehouse_export_hash_salt)
* [`batch_export_cron_times`](#batch_export_cron_times)
* [`manage_simplesamlphp`](#manage_simplesamlphp)
* [`simplesamlphp_config_content`](#simplesamlphp_config_content)
* [`simplesamlphp_config_source`](#simplesamlphp_config_source)
* [`simplesamlphp_authsources_content`](#simplesamlphp_authsources_content)
* [`simplesamlphp_authsources_source`](#simplesamlphp_authsources_source)
* [`simplesamlphp_metadata_content`](#simplesamlphp_metadata_content)
* [`simplesamlphp_metadata_source`](#simplesamlphp_metadata_source)
* [`simplesamlphp_cert_country`](#simplesamlphp_cert_country)
* [`simplesamlphp_cert_organization`](#simplesamlphp_cert_organization)
* [`simplesamlphp_cert_commonname`](#simplesamlphp_cert_commonname)
* [`akrr_source_url`](#akrr_source_url)
* [`akrr_version`](#akrr_version)
* [`akrr_home`](#akrr_home)
* [`manage_akrr_user`](#manage_akrr_user)
* [`akrr_user`](#akrr_user)
* [`akrr_user_group`](#akrr_user_group)
* [`akrr_user_group_gid`](#akrr_user_group_gid)
* [`akrr_user_uid`](#akrr_user_uid)
* [`akrr_user_shell`](#akrr_user_shell)
* [`akrr_user_home`](#akrr_user_home)
* [`akrr_user_managehome`](#akrr_user_managehome)
* [`akrr_user_comment`](#akrr_user_comment)
* [`akrr_user_system`](#akrr_user_system)
* [`akrr_restapi_port`](#akrr_restapi_port)
* [`akrr_restapi_rw_password`](#akrr_restapi_rw_password)
* [`akrr_restapi_ro_password`](#akrr_restapi_ro_password)
* [`akrr_cron_mailto`](#akrr_cron_mailto)
* [`akrr_ingestor_cron_times`](#akrr_ingestor_cron_times)
* [`appkernel_reports_manager_cron_times`](#appkernel_reports_manager_cron_times)
* [`supremm_version`](#supremm_version)
* [`supremm_package_ensure`](#supremm_package_ensure)
* [`supremm_package_url`](#supremm_package_url)
* [`supremm_package_name`](#supremm_package_name)
* [`supremm_mongodb_password`](#supremm_mongodb_password)
* [`supremm_mongodb_host`](#supremm_mongodb_host)
* [`supremm_mongodb_uri`](#supremm_mongodb_uri)
* [`supremm_mongodb_replica_set`](#supremm_mongodb_replica_set)
* [`supremm_resources`](#supremm_resources)
* [`supremm_update_cron_times`](#supremm_update_cron_times)
* [`ingest_jobscripts_cron_times`](#ingest_jobscripts_cron_times)
* [`aggregate_supremm_cron_times`](#aggregate_supremm_cron_times)
* [`supremm_archive_out_dir`](#supremm_archive_out_dir)
* [`use_pcp`](#use_pcp)
* [`pcp_declare_method`](#pcp_declare_method)
* [`pcp_resource`](#pcp_resource)
* [`pcp_pmlogger_path_suffix`](#pcp_pmlogger_path_suffix)
* [`pcp_pmlogger_config_template`](#pcp_pmlogger_config_template)
* [`pcp_pmlogger_config_source`](#pcp_pmlogger_config_source)
* [`pcp_logging_static_freq`](#pcp_logging_static_freq)
* [`pcp_logging_standard_freq`](#pcp_logging_standard_freq)
* [`pcp_static_metrics`](#pcp_static_metrics)
* [`pcp_standard_metrics`](#pcp_standard_metrics)
* [`pcp_environ_metrics`](#pcp_environ_metrics)
* [`pcp_merge_metrics`](#pcp_merge_metrics)
* [`pcp_hotproc_exclude_users`](#pcp_hotproc_exclude_users)
* [`storage_roles_source`](#storage_roles_source)
* [`storage_cron_times`](#storage_cron_times)

##### <a name="version"></a>`version`

Data type: `String`

Version of XDMoD to install

Default value: `$xdmod::params::version`

##### <a name="xdmod_appkernels_version"></a>`xdmod_appkernels_version`

Data type: `String`

Version of XDMoD AppKernels to install

Default value: `$xdmod::params::xdmod_appkernels_version`

##### <a name="xdmod_supremm_version"></a>`xdmod_supremm_version`

Data type: `String`

Version of XDMoD SUPReMM to install

Default value: `$xdmod::params::xdmod_supremm_version`

##### <a name="database"></a>`database`

Data type: `Boolean`

Sets database role

Default value: ``true``

##### <a name="web"></a>`web`

Data type: `Boolean`

Sets web role

Default value: ``true``

##### <a name="akrr"></a>`akrr`

Data type: `Boolean`

Sets akrr role

Default value: ``false``

##### <a name="supremm"></a>`supremm`

Data type: `Boolean`

Sets supremm role

Default value: ``false``

##### <a name="supremm_database"></a>`supremm_database`

Data type: `Boolean`

Sets supremm database role

Default value: ``false``

##### <a name="compute"></a>`compute`

Data type: `Boolean`

Sets compute role

Default value: ``false``

##### <a name="enable_appkernel"></a>`enable_appkernel`

Data type: `Boolean`

Enable XDMoD AppKernel support

Default value: ``false``

##### <a name="enable_supremm"></a>`enable_supremm`

Data type: `Boolean`

Enable XDMod SUPReMM support

Default value: ``false``

##### <a name="enable_cloud_realm"></a>`enable_cloud_realm`

Data type: `Boolean`

Enable the XDMoD cloud realm by adding the necessary database

Default value: ``false``

##### <a name="local_repo_name"></a>`local_repo_name`

Data type: `Optional[String]`

Name of yum repo hosting RPMs

Default value: ``undef``

##### <a name="manage_epel"></a>`manage_epel`

Data type: `Boolean`

Boolean that sets if EPEL should be managed

Default value: ``true``

##### <a name="package_ensure"></a>`package_ensure`

Data type: `String`

XDMoD package ensure property

Default value: `'present'`

##### <a name="xdmod_supremm_package_ensure"></a>`xdmod_supremm_package_ensure`

Data type: `String`

XDMoD supremm package ensure property

Default value: `'present'`

##### <a name="xdmod_appkernels_package_ensure"></a>`xdmod_appkernels_package_ensure`

Data type: `String`

XDMoD appkernels package ensure property

Default value: `'present'`

##### <a name="package_name"></a>`package_name`

Data type: `String`

XDMoD package name

Default value: `$xdmod::params::package_name`

##### <a name="package_url"></a>`package_url`

Data type: `Variant[Stdlib::HTTPSUrl, Stdlib::HTTPUrl]`

XDMoD package RPM URL, not used if `local_repo_name` is defined

Default value: `$xdmod::params::package_url`

##### <a name="appkernels_package_name"></a>`appkernels_package_name`

Data type: `String`

XDMoD appkernels package name

Default value: `$xdmod::params::appkernels_package_name`

##### <a name="appkernels_package_url"></a>`appkernels_package_url`

Data type: `Variant[Stdlib::HTTPSUrl, Stdlib::HTTPUrl]`

XDMoD appkernels package RPM URL, not used if `local_repo_name` is defined

Default value: `$xdmod::params::appkernels_package_url`

##### <a name="xdmod_supremm_package_name"></a>`xdmod_supremm_package_name`

Data type: `String`

XDMoD supremm package name

Default value: `$xdmod::params::xdmod_supremm_package_name`

##### <a name="xdmod_supremm_package_url"></a>`xdmod_supremm_package_url`

Data type: `Variant[Stdlib::HTTPSUrl, Stdlib::HTTPUrl]`

XDMoD supremm package RPM URL, not used if `local_repo_name` is defined

Default value: `$xdmod::params::xdmod_supremm_package_url`

##### <a name="database_host"></a>`database_host`

Data type: `String`

XDMoD database host

Default value: `'localhost'`

##### <a name="database_port"></a>`database_port`

Data type: `Integer`

XDMoD database port

Default value: `3306`

##### <a name="database_user"></a>`database_user`

Data type: `String`

XDMoD database user

Default value: `'xdmod'`

##### <a name="database_password"></a>`database_password`

Data type: `String`

XDMoD database password

Default value: `'changeme'`

##### <a name="akrr_database_user"></a>`akrr_database_user`

Data type: `String`

AKRR database user

Default value: `'akrr'`

##### <a name="akrr_database_password"></a>`akrr_database_password`

Data type: `String`

AKRR database password

Default value: `'changeme'`

##### <a name="web_host"></a>`web_host`

Data type: `String`

FQDN of web host

Default value: `'localhost'`

##### <a name="akrr_host"></a>`akrr_host`

Data type: `String`

FQDN of AKRR host

Default value: `'localhost'`

##### <a name="scheduler"></a>`scheduler`

Data type: `Enum['slurm','torque','pbs','sge']`

Scheduler to shred, used to define default shred commands and PI column

Default value: `'slurm'`

##### <a name="shredder_command"></a>`shredder_command`

Data type: `Optional[Variant[String, Array]]`

Shred command(s)

Default value: ``undef``

##### <a name="shred_hour_start"></a>`shred_hour_start`

Data type: `Integer[0,23]`

The numeric hour to start shredding

Default value: `1`

##### <a name="shred_minutes"></a>`shred_minutes`

Data type: `Integer`

Time in minutes between shred operations if multiple shred commands

Default value: `5`

##### <a name="ingest_hour"></a>`ingest_hour`

Data type: `Optional[Integer[0,23]]`

The numeric hour to start ingest

Default value: ``undef``

##### <a name="enable_update_check"></a>`enable_update_check`

Data type: `Boolean`

Enable XDMoD update check

Default value: ``true``

##### <a name="manage_apache_vhost"></a>`manage_apache_vhost`

Data type: `Boolean`

Manage the XMDoD Apache Virtual Host

Default value: ``true``

##### <a name="apache_vhost_name"></a>`apache_vhost_name`

Data type: `String`

The Apache Virtual Host name

Default value: `$xdmod::params::apache_vhost_name`

##### <a name="apache_ssl_cert"></a>`apache_ssl_cert`

Data type: `Stdlib::Unixpath`

Path to SSL cert used by Apache

Default value: `'/etc/pki/tls/certs/localhost.crt'`

##### <a name="apache_ssl_key"></a>`apache_ssl_key`

Data type: `Stdlib::Unixpath`

Path to SSL private key used by Apache

Default value: `'/etc/pki/tls/private/localhost.key'`

##### <a name="apache_ssl_chain"></a>`apache_ssl_chain`

Data type: `Optional[Stdlib::Unixpath]`

Path to SSL chain used by Apache

Default value: ``undef``

##### <a name="portal_settings"></a>`portal_settings`

Data type: `Hash`

Hash of portal_settings.ini settings to pass to `xdmod_portal_setting` resources

Default value: `$xdmod::params::portal_settings`

##### <a name="hierarchy_levels"></a>`hierarchy_levels`

Data type: `Xdmod::Hierarchy_Levels`

Hierarchy levels used when defining hierarchies

Default value: `$xdmod::params::hierarchy_levels`

##### <a name="hierarchies"></a>`hierarchies`

Data type: `Array`

Hierarchy lines, see XDMoD docs

Default value: `$xdmod::params::hierarchies`

##### <a name="group_to_hierarchy"></a>`group_to_hierarchy`

Data type: `Hash`

Group to Hierarchy mappings, see XDMoD docs

Default value: `$xdmod::params::group_to_hierarchy`

##### <a name="user_pi_names"></a>`user_pi_names`

Data type: `Array`

User and PI names, see XDMoD docs

Default value: `$xdmod::params::user_pi_names`

##### <a name="organization_name"></a>`organization_name`

Data type: `Optional[String]`

Organization name for XDMoD instance

Default value: ``undef``

##### <a name="organization_abbrev"></a>`organization_abbrev`

Data type: `Optional[String]`

Organization abbreviation for XDMoD instance

Default value: ``undef``

##### <a name="resources"></a>`resources`

Data type: `Array[Xdmod::Resource]`

Resources to define resources.json

Default value: `[]`

##### <a name="resource_specs"></a>`resource_specs`

Data type: `Array[Xdmod::Resource_Spec]`

Resource specs for resource_specs.json

Default value: `[]`

##### <a name="sender_email"></a>`sender_email`

Data type: `String`

Configure sender for EMail

Default value: `$xdmod::params::sender_email`

##### <a name="debug_recipient"></a>`debug_recipient`

Data type: `String`

Configure email addres to receive debug information

Default value: `''`

##### <a name="php_timezone"></a>`php_timezone`

Data type: `Optional[String]`

PHP Timezone

Default value: ``undef``

##### <a name="center_logo_source"></a>`center_logo_source`

Data type: `Optional[String]`

Source to image that will be used as center logo in XDMoD

Default value: ``undef``

##### <a name="center_logo_width"></a>`center_logo_width`

Data type: `Optional[Integer]`

The width of file from `center_logo_source`

Default value: ``undef``

##### <a name="user_dashboard"></a>`user_dashboard`

Data type: `Enum['on','off']`

The value for `user_dashboard` in portal_settings.ini

Default value: `'off'`

##### <a name="cors_domains"></a>`cors_domains`

Data type: `Array`

The value for `domains` in `cors` section of portal_settings.ini

Default value: `[]`

##### <a name="manage_user"></a>`manage_user`

Data type: `Boolean`

Boolean that sets if managing XMDoD user

Default value: ``true``

##### <a name="user_uid"></a>`user_uid`

Data type: `Optional[Integer]`

XMDoD user UID

Default value: ``undef``

##### <a name="group_gid"></a>`group_gid`

Data type: `Optional[Integer]`

XDMoD user group GID

Default value: ``undef``

##### <a name="data_warehouse_export_directory"></a>`data_warehouse_export_directory`

Data type: `Stdlib::Absolutepath`

Path used for data warehouse export

Default value: `'/var/spool/xdmod/export'`

##### <a name="data_warehouse_export_retention_duration_days"></a>`data_warehouse_export_retention_duration_days`

Data type: `Integer`

portal_settings.ini section=data_warehouse_export setting=retention_duration_days

Default value: `30`

##### <a name="data_warehouse_export_hash_salt"></a>`data_warehouse_export_hash_salt`

Data type: `String`

portal_settings.ini section=data_warehouse_export setting=hash_salt

Default value: `sha256($::fqdn)`

##### <a name="batch_export_cron_times"></a>`batch_export_cron_times`

Data type: `Array[Integer, 2 ,2]`

cron times to run batch export

Default value: `[0,4]`

##### <a name="manage_simplesamlphp"></a>`manage_simplesamlphp`

Data type: `Boolean`

Boolean that sets if managing simplesamlphp

Default value: ``false``

##### <a name="simplesamlphp_config_content"></a>`simplesamlphp_config_content`

Data type: `Optional[String]`

The content for simplesamlphp config

Default value: ``undef``

##### <a name="simplesamlphp_config_source"></a>`simplesamlphp_config_source`

Data type: `Optional[String]`

The source for simplesamlphp config

Default value: ``undef``

##### <a name="simplesamlphp_authsources_content"></a>`simplesamlphp_authsources_content`

Data type: `Optional[String]`

The content for simplesaml php authsources

Default value: ``undef``

##### <a name="simplesamlphp_authsources_source"></a>`simplesamlphp_authsources_source`

Data type: `Optional[String]`

The source for simplesaml php authsources

Default value: ``undef``

##### <a name="simplesamlphp_metadata_content"></a>`simplesamlphp_metadata_content`

Data type: `Optional[String]`

The simplesamlphp metadata content

Default value: ``undef``

##### <a name="simplesamlphp_metadata_source"></a>`simplesamlphp_metadata_source`

Data type: `Optional[String]`

The simplesamlphp metadata source

Default value: ``undef``

##### <a name="simplesamlphp_cert_country"></a>`simplesamlphp_cert_country`

Data type: `String`

The simplesamlphp cert country

Default value: `'US'`

##### <a name="simplesamlphp_cert_organization"></a>`simplesamlphp_cert_organization`

Data type: `Optional[String]`

The simplesamlphp cert organization

Default value: ``undef``

##### <a name="simplesamlphp_cert_commonname"></a>`simplesamlphp_cert_commonname`

Data type: `Optional[String]`

The simplesamlphp cert commonname

Default value: ``undef``

##### <a name="akrr_source_url"></a>`akrr_source_url`

Data type: `Variant[Stdlib::HTTPSUrl, Stdlib::HTTPUrl]`

The AKRR source URL

Default value: `$xdmod::params::akrr_source_url`

##### <a name="akrr_version"></a>`akrr_version`

Data type: `String`

The AKRR version. This version is used to build default `akrr_source_url`.

Default value: `$xdmod::params::akrr_version`

##### <a name="akrr_home"></a>`akrr_home`

Data type: `Optional[Stdlib::Unixpath]`

AKRR home path

Default value: ``undef``

##### <a name="manage_akrr_user"></a>`manage_akrr_user`

Data type: `Boolean`

Boolean to manage AKRR user

Default value: ``true``

##### <a name="akrr_user"></a>`akrr_user`

Data type: `String`

AKRR username

Default value: `'akrr'`

##### <a name="akrr_user_group"></a>`akrr_user_group`

Data type: `String`

AKRR user group name

Default value: `'akrr'`

##### <a name="akrr_user_group_gid"></a>`akrr_user_group_gid`

Data type: `Optional[Integer]`

AKRR user gropu GID

Default value: ``undef``

##### <a name="akrr_user_uid"></a>`akrr_user_uid`

Data type: `Optional[Integer]`

AKRR user UID

Default value: ``undef``

##### <a name="akrr_user_shell"></a>`akrr_user_shell`

Data type: `Stdlib::Unixpath`

AKRR user shell

Default value: `'/bin/bash'`

##### <a name="akrr_user_home"></a>`akrr_user_home`

Data type: `Optional[Stdlib::Unixpath]`

AKRR user home

Default value: ``undef``

##### <a name="akrr_user_managehome"></a>`akrr_user_managehome`

Data type: `Boolean`

AKRR user managehome property

Default value: ``true``

##### <a name="akrr_user_comment"></a>`akrr_user_comment`

Data type: `String`

AKRR user comment

Default value: `'AKRR'`

##### <a name="akrr_user_system"></a>`akrr_user_system`

Data type: `Boolean`

AKRR user system property

Default value: ``true``

##### <a name="akrr_restapi_port"></a>`akrr_restapi_port`

Data type: `Integer`

AKRR restapi port

Default value: `8091`

##### <a name="akrr_restapi_rw_password"></a>`akrr_restapi_rw_password`

Data type: `String`

AKRR restapi RW password

Default value: `$xdmod::params::akrr_restapi_rw_password`

##### <a name="akrr_restapi_ro_password"></a>`akrr_restapi_ro_password`

Data type: `String`

AKRR restapi RO password

Default value: `$xdmod::params::akrr_restapi_ro_password`

##### <a name="akrr_cron_mailto"></a>`akrr_cron_mailto`

Data type: `Optional[String]`

AKRR cron MAILTO

Default value: ``undef``

##### <a name="akrr_ingestor_cron_times"></a>`akrr_ingestor_cron_times`

Data type: `Array[Integer, 2, 2]`

AKRR ingestor cron times

Default value: `[0,5]`

##### <a name="appkernel_reports_manager_cron_times"></a>`appkernel_reports_manager_cron_times`

Data type: `Array[Integer, 2, 2]`

AppKernel report manager cron times

Default value: `[0,6]`

##### <a name="supremm_version"></a>`supremm_version`

Data type: `String`

Version of SUPReMM to install, builds `supremm_package_url` if not defined

Default value: `$xdmod::params::supremm_version`

##### <a name="supremm_package_ensure"></a>`supremm_package_ensure`

Data type: `String`

SUPReMM package ensure property

Default value: `'present'`

##### <a name="supremm_package_url"></a>`supremm_package_url`

Data type: `Variant[Stdlib::HTTPSUrl, Stdlib::HTTPUrl]`

The URL to download SUPReMM RPM from

Default value: `$xdmod::params::supremm_package_url`

##### <a name="supremm_package_name"></a>`supremm_package_name`

Data type: `String`

SUPReMM RPM package name

Default value: `'supremm'`

##### <a name="supremm_mongodb_password"></a>`supremm_mongodb_password`

Data type: `String`

SUPReMM mongodb password

Default value: `'changeme'`

##### <a name="supremm_mongodb_host"></a>`supremm_mongodb_host`

Data type: `String`

SUPReMM mongodb host

Default value: `'localhost'`

##### <a name="supremm_mongodb_uri"></a>`supremm_mongodb_uri`

Data type: `Optional[String]`

SUPReMM mongodb URI

Default value: ``undef``

##### <a name="supremm_mongodb_replica_set"></a>`supremm_mongodb_replica_set`

Data type: `Optional[String]`

SUPReMM mongodb replica set

Default value: ``undef``

##### <a name="supremm_resources"></a>`supremm_resources`

Data type: `Array[Xdmod::Supremm_Resource]`

SUPReMM resources

Default value: `[]`

##### <a name="supremm_update_cron_times"></a>`supremm_update_cron_times`

Data type: `Array[Integer, 2, 2]`

The cron times to run supremm_update

Default value: `[0,2]`

##### <a name="ingest_jobscripts_cron_times"></a>`ingest_jobscripts_cron_times`

Data type: `Array[Integer, 2, 2]`

The cron times to ingest job scripts

Default value: `[0,3]`

##### <a name="aggregate_supremm_cron_times"></a>`aggregate_supremm_cron_times`

Data type: `Array[Integer, 2, 2]`

The cron times to run supremm aggregation

Default value: `[0,4]`

##### <a name="supremm_archive_out_dir"></a>`supremm_archive_out_dir`

Data type: `Stdlib::Absolutepath`

The path to supremm archive out

Default value: `'/dev/shm/supremm_test'`

##### <a name="use_pcp"></a>`use_pcp`

Data type: `Boolean`

Boolean that PCP should be used for compute environment

Default value: ``true``

##### <a name="pcp_declare_method"></a>`pcp_declare_method`

Data type: `Enum['include', 'resource']`

Should pcp class be included or declared like a resource

Default value: `'resource'`

##### <a name="pcp_resource"></a>`pcp_resource`

Data type: `Optional[String]`

PCP resource name

Default value: ``undef``

##### <a name="pcp_pmlogger_path_suffix"></a>`pcp_pmlogger_path_suffix`

Data type: `Optional[String]`

PCP pmlogger path suffix

Default value: ``undef``

##### <a name="pcp_pmlogger_config_template"></a>`pcp_pmlogger_config_template`

Data type: `String`

Template for pmlogger config

Default value: `'xdmod/supremm/compute/pcp/pmlogger-supremm.config.erb'`

##### <a name="pcp_pmlogger_config_source"></a>`pcp_pmlogger_config_source`

Data type: `Optional[String]`

Source for pmlogger config

Default value: ``undef``

##### <a name="pcp_logging_static_freq"></a>`pcp_logging_static_freq`

Data type: `String`

Frequency for PCP logging static metrics

Default value: `'1 hour'`

##### <a name="pcp_logging_standard_freq"></a>`pcp_logging_standard_freq`

Data type: `String`

Frequency for PCP logging standard metrics

Default value: `'30 sec'`

##### <a name="pcp_static_metrics"></a>`pcp_static_metrics`

Data type: `Array`

PCP static metrics

Default value: `$xdmod::params::supremm_pcp_static_metrics`

##### <a name="pcp_standard_metrics"></a>`pcp_standard_metrics`

Data type: `Array`

PCP standard metrics

Default value: `$xdmod::params::supremm_pcp_standard_metrics`

##### <a name="pcp_environ_metrics"></a>`pcp_environ_metrics`

Data type: `Array`

PCP environment metrics

Default value: `$xdmod::params::supremm_pcp_environ_metrics`

##### <a name="pcp_merge_metrics"></a>`pcp_merge_metrics`

Data type: `Boolean`

Boolean that PCP metrics should be merged with defaults

Default value: ``true``

##### <a name="pcp_hotproc_exclude_users"></a>`pcp_hotproc_exclude_users`

Data type: `Array`

Users to exclude from PCP hotproc

Default value: `$xdmod::params::supremm_pcp_hotproc_exclude_users`

##### <a name="storage_roles_source"></a>`storage_roles_source`

Data type: `String`

The source of storage roles.json

Default value: `'puppet:///modules/xdmod/roles.d/storage.json'`

##### <a name="storage_cron_times"></a>`storage_cron_times`

Data type: `Array[Integer, 2, 2]`

The cron times for storage shred/ingest

Default value: `[0,5]`

## Defined types

### <a name="xdmodakrrsetting"></a>`xdmod::akrr::setting`

Manage AKRR config setting value

#### Parameters

The following parameters are available in the `xdmod::akrr::setting` defined type:

* [`value`](#value)
* [`quote`](#quote)

##### <a name="value"></a>`value`

Data type: `Any`

Setting value

##### <a name="quote"></a>`quote`

Data type: `Any`

Should value be quoted

Default value: ``undef``

## Resource types

### <a name="xdmod_appkernel_setting"></a>`xdmod_appkernel_setting`

Section/setting name to manage from appkernels.ini

#### Properties

The following properties are available in the `xdmod_appkernel_setting` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

##### `value`

The value of the setting to be defined.

#### Parameters

The following parameters are available in the `xdmod_appkernel_setting` type.

* [`name`](#name)
* [`provider`](#provider)
* [`secret`](#secret)

##### <a name="name"></a>`name`

namevar

Section/setting name to manage from appkernels.ini

##### <a name="provider"></a>`provider`

The specific backend to use for this `xdmod_appkernel_setting` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

##### <a name="secret"></a>`secret`

Valid values: ``true``, ``false``

Whether to hide the value from Puppet logs. Defaults to `false`.

Default value: ``false``

### <a name="xdmod_portal_setting"></a>`xdmod_portal_setting`

Section/setting name to manage from portal_settings.ini

#### Properties

The following properties are available in the `xdmod_portal_setting` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

##### `value`

The value of the setting to be defined.

#### Parameters

The following parameters are available in the `xdmod_portal_setting` type.

* [`name`](#name)
* [`provider`](#provider)
* [`secret`](#secret)

##### <a name="name"></a>`name`

namevar

Section/setting name to manage from portal_settings.ini

##### <a name="provider"></a>`provider`

The specific backend to use for this `xdmod_portal_setting` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

##### <a name="secret"></a>`secret`

Valid values: ``true``, ``false``

Whether to hide the value from Puppet logs. Defaults to `false`.

Default value: ``false``

### <a name="xdmod_supremm_setting"></a>`xdmod_supremm_setting`

Section/setting name to manage from supremm.ini

#### Properties

The following properties are available in the `xdmod_supremm_setting` type.

##### `ensure`

Valid values: `present`, `absent`

The basic property that the resource should be in.

Default value: `present`

##### `value`

The value of the setting to be defined.

#### Parameters

The following parameters are available in the `xdmod_supremm_setting` type.

* [`name`](#name)
* [`provider`](#provider)
* [`secret`](#secret)

##### <a name="name"></a>`name`

namevar

Section/setting name to manage from supremm.ini

##### <a name="provider"></a>`provider`

The specific backend to use for this `xdmod_supremm_setting` resource. You will seldom need to specify this --- Puppet
will usually discover the appropriate provider for your platform.

##### <a name="secret"></a>`secret`

Valid values: ``true``, ``false``

Whether to hide the value from Puppet logs. Defaults to `false`.

Default value: ``false``

## Functions

### <a name="xdmodmember_substring"></a>`xdmod::member_substring`

Type: Ruby 4.x API

Function to test member substring

#### Examples

##### Return `present`

```puppet
member(['nfsclient.bytes.write.server','infiniband.hca.type'], '^nfsclient')
```

##### Return `absent`

```puppet
member(['nfsclient.bytes.write.server','nfsclient.bytes.write.server'], '^infiniband')
```

#### `xdmod::member_substring(Array $array, String $substring)`

Function to test member substring

Returns: `String` Returns `present` if substring in array

##### Examples

###### Return `present`

```puppet
member(['nfsclient.bytes.write.server','infiniband.hca.type'], '^nfsclient')
```

###### Return `absent`

```puppet
member(['nfsclient.bytes.write.server','nfsclient.bytes.write.server'], '^infiniband')
```

##### `array`

Data type: `Array`

The array to check.

##### `substring`

Data type: `String`

The substring used for check.

## Data types

### <a name="xdmodhierarchy_levels"></a>`Xdmod::Hierarchy_Levels`

The Xdmod::Hierarchy_Levels data type.

Alias of

```puppet
Struct[{
  top => Struct[{
    label => String,
    info  => String,
  }],
  Optional[middle] => Struct[{
    label => String,
    info  => String,
  }],
  Optional[bottom] => Struct[{
    label => String,
    info  => String,
  }],
}]
```

### <a name="xdmodresource"></a>`Xdmod::Resource`

The Xdmod::Resource data type.

Alias of

```puppet
Struct[{
  resource => String,
  name => String,
  Optional[description] => String,
  Optional[resource_type] => String,
  Optional[pi_column] => String,
  Optional[timezone] => String,
  Optional[shared_jobs] => Boolean,
  Optional[shred_directory] => Stdlib::Absolutepath,
}]
```

### <a name="xdmodresource_spec"></a>`Xdmod::Resource_Spec`

The Xdmod::Resource_Spec data type.

Alias of

```puppet
Struct[{
  resource => String,
  start_date => Optional[String],
  end_date => Optional[String],
  processors => Integer,
  nodes => Integer,
  ppn => Integer,
}]
```

### <a name="xdmodsupremm_resource"></a>`Xdmod::Supremm_Resource`

The Xdmod::Supremm_Resource data type.

Alias of

```puppet
Struct[{
  resource => String,
  resource_id => Integer,
  Optional[enabled] => Boolean,
  Optional[datasetmap] => String,
  Optional[datasetmap_source] => String,
  Optional[hardware] => Struct[{
    Optional[gpfs] => Variant[String, Array],
    Optional[network] => Variant[String, Array],
    Optional[mounts] => Hash,
    Optional[block] => Variant[String, Array],
    Optional[gpus] => Variant[String, Array],
  }],
  Optional[hostname_mode] => Enum['fqdn','hostname'],
  Optional[pcp_log_dir] => Stdlib::Unixpath,
  Optional[script_dir] => Stdlib::Unixpath,
  Optional[fast_index] => Boolean,
  Optional[timezone] => String,
}]
```

